--[[ ä

	Name: Advanced Questbook
	By: Crypton

]]
AQB_VER_NUM = 1.35;
AQB_SDB_VER = "SDB: v.2.1.1.1909";
AQB_ADDON_NAME = "Advanced Quest Book";
AQB_TITLE_PAGE = AQB_ADDON_NAME.." v."..AQB_VER_NUM.." Beta";
AQB_PATH = "Interface/AddOns/AdvQuestBook/";
AQB_LIB_PATH = AQB_PATH.."lib/";
AQB_LANG_PATH = AQB_PATH.."local/";
AQB_DB_PATH = AQB_LIB_PATH.."db/";
AQB_ICON_PATH = AQB_PATH.."images/";
AQB_ICON_1 = AQB_ICON_PATH.."fin.png";
AQB_ICON_2 = AQB_ICON_PATH.."inc.png";
AQB_ICON_3 = AQB_ICON_PATH.."index.png";
AQB_ICON_4 = AQB_ICON_PATH.."item.png";
AQB_DEBUG_GAMESTRINGS = false;
AQB_UPDATE = false;
AQB_TTW = 3;
AQB_ENABLE_ICONS = false;
AQB_SHOW = false;
AQB_LASTMAPID= 0;
AQB_LASTSCALE = 0;
AQB_FIN_COUNT = 0;
AQB_INC_COUNT = 0;
AQB_IDX_COUNT = 0;
AQB_ITEM_COUNT = 0;
AQB_SHA_COUNT = 0;
AQB_QST_ICOUNT = 0;
AQB_LAST_SHARE = 0;
AQB_MIN_ST = 3;
AQB_MAX_WIN = 16;
AQB_QST_MAX = 100;
AQB_QST_RESULTS = {};
AQB_SUPPORTED = {"ENUS", "ENEU", "DE", "FR", "ES", "JP", "KR", "TW", "CN"};
AQB_REPLIST = {"%<%S%>", "%<%/%S%>", "%<%C%R%>", "%<%/%C%R%>", "%<%C%S%>", "%<%/%C%S%>", "%<%C%M%>", "%<%/%C%M%>", "%<%C%N%>", "%<%/%C%N%>", "%<%C%Y%>", "%<%/%C%Y%>", "%<%C%B%>", "%<%/%C%B%>", "%<%C%P%>", "%<%/%C%P%>"};
--[[

	**[START pbi]** AND **[END pbi]**

	the code within those lines is
	released as Attribution-Noncommercial-Share Alike 3.0 Unported by novayuna
	of pbinfo addon: http://creativecommons.org/licenses/by-nc-sa/3.0/

]]
-- **[START pbi]**
function AQB_IsEmpty(str, zero)
	if (type(str) == "nil" or str == "" or (zero == true and str == 0)) then
		return true;
	end
	return false;
end
-- **[END pbi]**

function AQB_FileLoader(AQB_FPATH, AQB_FNAME)
	local func, err = loadfile(AQB_FPATH..AQB_FNAME);
	if (err) then
		DEFAULT_CHAT_FRAME:AddMessage("Error loading file: "..AQB_FNAME.. " : "..err);
		return false;
	end
	dofile(AQB_FPATH..AQB_FNAME);
	return true;
end

AQB_FileLoader(AQB_LIB_PATH, "AdvQuestBookDefaultConfig.lua");

AQB_LOCAL = GetLanguage();

if (AQB_LOCAL == "ENUS" or AQB_LOCAL == "ENEU") then
	AQB_LOCAL = "ENUS";
	AQB_LANG_FILE = "en";
elseif (AQB_LOCAL == "DE") then
	AQB_LANG_FILE = "de";
elseif (AQB_LOCAL == "FR") then
	AQB_LANG_FILE = "fr";
elseif (AQB_LOCAL == "ES") then
	AQB_LANG_FILE = "es";
elseif (AQB_LOCAL == "JP") then
	AQB_LANG_FILE = "jp";
elseif (AQB_LOCAL == "KR") then
	AQB_LANG_FILE = "kr";
elseif (AQB_LOCAL == "TW") then
	AQB_LANG_FILE = "tw";
elseif (AQB_LOCAL == "CN") then
	AQB_LANG_FILE = "cn";
else
	AQB_LOCAL = "ENUS";
	AQB_LANG_FILE = "en";
	DEFAULT_CHAT_FRAME:AddMessage("|cFFffffff"..AQB_ADDON_NAME..": does not currently support your language version of the game. Please contact Crypton on curse.com or curseforge.com if you would like to help add support for your language.|r");
end

AQB_FileLoader(AQB_LANG_PATH, AQB_LANG_FILE..".lua");
AQB_FileLoader(AQB_LIB_PATH, "AdvQuestBookData.lua");
AQB_FileLoader(AQB_DB_PATH, "AdvQuestBookZones.lua");
AQB_FileLoader(AQB_DB_PATH, "AdvQuestBookMapID.lua");
AQB_FileLoader(AQB_DB_PATH, "AdvQuestBookCoords.lua");
AQB_FileLoader(AQB_DB_PATH, "AdvQuestBookAirships.lua");
AQB_FileLoader(AQB_DB_PATH, "AdvQuestBookEliteTrainers.lua");
AQB_FileLoader(AQB_DB_PATH, "AdvQuestBookSnoopLocs.lua");

function AQB_DecMagic(AQB_DECVAL, AQB_DEC)
	local aqbdec = tonumber(AQB_DEC);
	local aqbdecval = tonumber(AQB_DECVAL);
	local movedec = 10 ^ aqbdec;
	local result = aqbdecval * movedec;
	local shiftdec = 10 ^ 1;
	return math.floor(result * shiftdec) / shiftdec;
end

function round(val, places)
	local dec = 10^(places or 0);
	return math.floor(val * dec + 0.5) / dec;
end

function AQB_DEBUG_MESSAGE(AQB_DBG_MSG)
	DEFAULT_CHAT_FRAME:AddMessage("AQB Debug: "..AQB_DBG_MSG);
	return;
end

function AdvQuestBookConfig_Defaults()
	local i;
	AQB_UPDATE = false;
	local defaultcount = table.getn(AQB_Default_Config["settings"]);
	if (AQB_IsEmpty(AdvQuestBook_Config, true)) then
		AdvQuestBook_Config = AQB_Default_Config;
		SaveVariables("AdvQuestBook_Config");
		DEFAULT_CHAT_FRAME:AddMessage(AQB_ADDON_NAME.." "..AdvQuestBook_Messages["AQB_DFAULTSETLOAD"].."...");
	end
	for i = 1, defaultcount do
		if (AQB_IsEmpty(AdvQuestBook_Config["settings"][i], true)) then
			AQB_UPDATE = true;
			AdvQuestBook_Config["settings"][i] = AQB_Default_Config["settings"][i];
			SaveVariables("AdvQuestBook_Config");
		end
	end
	if (AQB_IsEmpty(AdvQuestBook_Config["minibook"], true)) then
		AQB_UPDATE = true;
		AdvQuestBook_Config["minibook"] = AQB_Default_Config["minibook"];
		SaveVariables("AdvQuestBook_Config");
	end
	if (AQB_IsEmpty(AdvQuestBook_Config["version"], true)) then
		AQB_UPDATE = true;
		AdvQuestBook_Config["version"] = AQB_Default_Config["version"];
		SaveVariables("AdvQuestBook_Config");
	end
	if (tonumber(AdvQuestBook_Config["version"]) < tonumber(AQB_VER_NUM)) then
		AQB_UPDATE = true;
		AdvQuestBook_Config["version"] = AQB_VER_NUM;
		SaveVariables("AdvQuestBook_Config");
		if (not AddonManager) then
			DEFAULT_CHAT_FRAME:AddMessage(string.format(AdvQuestBook_Messages["AQB_AMNOTFOUND"], AQB_ADDON_NAME, "|cFFffffff/aqb|r", AQB_ADDON_NAME));
		end
	end
	if (AQB_UPDATE) then
		DEFAULT_CHAT_FRAME:AddMessage("|cFF22ff17"..AQB_ADDON_NAME.."|r |cFFffffff"..AdvQuestBook_Messages["AQB_SETSUPDATE"].."...|r");
		AQB_UPDATE = false;
	end
	if (AQB_LOCAL ~= "ENUS") then
		AdvQuestBook_Config["settings"][8]["value"] = false;
		AdvQuestBook_Config["settings"][9]["value"] = false;
		AdvQuestBook_Config["settings"][14]["value"] = false;
		SaveVariables("AdvQuestBook_Config");
		AdvQuestBookConfigPurgeButton:Hide();
		AdvQuestBookConfigCheckbox8:Hide();
		AdvQuestBookConfigCheckbox9:Hide();
		AdvQuestBookConfigCheckbox14:Hide();
	end
	return;
end

-- Not fully used, yet...
function AdvQuestBook_OrderByName(aqb1, aqb2)
	local i;
	local tmparr = {};
	for i in pairs(aqb1) do
		table.insert(tmparr, i)
	end
	table.sort(tmparr, aqb2);
	i = 0;
	local loopy = function()
		i = i + 1;
		if (tmparr[i] == nil) then
			return nil;
		else
			return tmparr[i], aqb1[tmparr[i]];
		end
	end
	return loopy;
end

function AdvQuestBook_SortByNum(t)
	local i;
	local j;
	local k = table.getn(t);
	local idxm;
	for i = 1, k, 1 do
		idxm = i;
		for j = i + 1, k, 1 do
			if (t[j] < t[idxm]) then
				idxm = j;
			end
		end
		t[i], t[idxm] = t[idxm], t[i];
	end
	return t;
end

function AdvQuestBook_ConvertCSV(s, t)
	local start = 1;
	local i = start;
	local nexti;
	repeat
		nexti = string.find(s, ',', start);
		table.insert(t, string.sub(s, start, nexti - 1));
		start = nexti + 1;
	until start > string.len(s);
	return t;
end

function AdvQuestBook_AutoMoveTo(this)
	local icon = getglobal(this);
	if (icon.mid ~= nil and icon.x ~= nil and icon.y ~= nil) then
		info = {};
		info.text = UI_AUTO_MOVE; 
		info.value = 0;
		info.func = WorldMap_AutoMove(icon.mid, icon.x, icon.y);
		info.owner = DropDownframe;
	end
end

function AdvQuestBook_eAutoMoveToByNPCID(this)
	local icon = getglobal(this);
	if (icon.enpcid ~= nil) then
		info = {};
		info.text = UI_AUTO_MOVE; 
		info.value = 0;
		info.func = WorldMap_AutoMoveByNpcID(icon.enpcid);
		info.owner = DropDownframe;
	end
end

-- No longer used, keeping just incase though.
function AdvQuestBook_GSubUTF8(str, start, numChars)
	local currentIndex = start;
	while (numChars > 0 and currentIndex <= #str) do
		local char = string.byte(str, currentIndex);
		if (char > 240) then
			currentIndex = currentIndex + 4;
		elseif (char > 225) then
			currentIndex = currentIndex + 3;
		elseif (char > 192) then
			currentIndex = currentIndex + 2;
		else 
			currentIndex = currentIndex + 1;
		end
		numChars = numChars - 1;
	end
	return str:sub(start, currentIndex - 1);
end

function AdvQuestBook_LevelTextColor(qlevel)
	local cl1, cl2 = UnitLevel("player");
	local diff = qlevel - cl1;
	local color;
	if (diff >= 5) then
		color = "FF1804";
	elseif (diff >= -3 and diff <= 4) then
		color = "F6FF04";
	else
		color = "00FB00";
	end
	return color;
end

--[[

	Worked, but not 100%. Sometimes would miss one or 2.

	for idmatch in string.gmatch(ztext, "%<(.+)%>") do
		ztext = string.gsub(ztext, "%<("..idmatch.."%>)", "");
	end

]]

function AdvQuestBook_ZoneParse(ztext)
	local i, v;
	local zname;
	local r;
	for _, r in pairs(AQB_REPLIST) do
		ztext = string.gsub(ztext, r, "");
	end
	for r in string.gmatch(ztext, "%[(SC_.+)%]") do
		ztext = string.gsub(ztext, "%["..r.."%]", TEXT(r));
	end
	ztext = string.gsub(ztext, "%[%$PLAYERNAME%]", "|cffffffff"..UnitName("player").."|r");
	for i, v in pairs(AdvQuestBookZones) do
		if (string.find(ztext, i)) then
			zname = "|cff128f01"..v.."|r";
			ztext = string.gsub(ztext, "%["..i.."%]", zname);
		end
	end
	return ztext;
end

function AdvQuestBook_IDParse(idtext)
	local idmatch;
	local idname;
	local idmark;
	local idcolor;
	local r;
	for _, r in pairs(AQB_REPLIST) do
		idtext = string.gsub(idtext, r, "");
	end
	for idmatch in string.gmatch(idtext, "%[(%d+)%]") do
		idmatch = tonumber(idmatch);
		if (idmatch >= 100004 and idmatch <= 102739) then
			idmark = "npc";
			idcolor = "0122ed";
		elseif (idmatch >= 110003 and idmatch <= 113582) then
			idmark = "npc";
			idcolor = "0122ed";
		else
			idmark = "item";
			idcolor = "ca5720";
		end
		if (string.len(idmatch) == 5) then
			idname = "|H"..idmark..":"..idmatch.."0|h|cff"..idcolor..TEXT("Sys"..idmatch.."0_name").."|r|h";
			idtext = string.gsub(idtext, "%["..idmatch.."%]", idname);
		else
			idname = "|H"..idmark..":"..idmatch.."|h|cff"..idcolor..TEXT("Sys"..idmatch.."_name").."|r|h";
			idtext = string.gsub(idtext, "%["..idmatch.."%]", idname);
		end
	end
	return idtext;
end

function AdvQuestBook_IDtoName(iid, docolor)
	local numid = tonumber(iid);
	local idname;
	local idmark;
	local idcolor;
	if (numid >= 100004 and numid <= 102739) then
		idmark = "npc";
		idcolor = "0122ed";
	elseif (numid >= 110003 and numid <= 113582) then
		idmark = "npc";
		idcolor = "0122ed";
	else
		idmark = "item";
		idcolor = "ca5720";
	end
	if (docolor) then
		idname = "|H"..idmark..":"..numid.."|h|cff"..idcolor..TEXT("Sys"..numid.."_name").."|r|h";
	else
		idname = TEXT("Sys"..idmatch.."_name");
	end
	return idname;
end

function AdvQuestBook_SavePatterns()
	local tmplang = GetLanguage();
	A_AQB_Strings = {};
	A_AQB_Strings[tmplang] = {};
	A_AQB_Strings[tmplang]["QUEST_MSG_FINISHED"] = TEXT("QUEST_MSG_FINISHED");
	A_AQB_Strings[tmplang]["QUEST_MSG_CONDITION_FINISHED"] = TEXT("QUEST_MSG_CONDITION_FINISHED");
	A_AQB_Strings[tmplang]["QUEST_MSG_ALREADY_GIVEUP"] = TEXT("QUEST_MSG_ALREADY_GIVEUP");
	A_AQB_Strings[tmplang]["QUEST_MSG_GET"] = TEXT("QUEST_MSG_GET");
	A_AQB_Strings[tmplang]["QUEST_MSG_GET_ITEM"] = TEXT("QUEST_MSG_GET_ITEM");
	A_AQB_Strings[tmplang]["QUEST_MSG_REQUEST_ITEM"] = TEXT("QUEST_MSG_REQUEST_ITEM");
	A_AQB_Strings[tmplang]["QUEST_MSG_REQUEST_KILL"] = TEXT("QUEST_MSG_REQUEST_KILL");
	A_AQB_Strings[tmplang]["QUEST_MSG_REQUEST_COMPLETE"] = TEXT("QUEST_MSG_REQUEST_COMPLETE");
	A_AQB_Strings[tmplang]["QUEST_MSG_REQUEST_KEYITEM"] = TEXT("QUEST_MSG_REQUEST_KEYITEM");
	A_AQB_Strings[tmplang]["SYS_PARTY_LEAVE"] = TEXT("SYS_PARTY_LEAVE");
	A_AQB_Strings[tmplang]["SYS_PARTY_JOIN"] = TEXT("SYS_PARTY_JOIN");
	A_AQB_Strings[tmplang]["SYS_PARTY_UNINVITE"] = TEXT("SYS_PARTY_UNINVITE");
	A_AQB_Strings[tmplang]["SYS_ADD_PARTY"] = TEXT("SYS_ADD_PARTY");
	A_AQB_Strings[tmplang]["QUEST_MSG_ALREADYDONE"] = TEXT("QUEST_MSG_ALREADYDONE");
	SaveVariables("A_AQB_Strings");
	A_AQB_Strings2 = {};
	A_AQB_Strings2[tmplang] = AdvQuestBookPatterns;
	SaveVariables("A_AQB_Strings2");
	return;
end

function AdvQuestBook_SetPatterns()
	local i, j, k, m, n;
	if (string.find(AdvQuestBookPatterns["AQB_QUEST_COMPLETE2"], ".+:%s\"%%s\"")) then
		AdvQuestBookPatterns["AQB_QUEST_COMPLETE2"] = string.gsub(AdvQuestBookPatterns["AQB_QUEST_COMPLETE2"], "\"%%s\"", "");
		AdvQuestBookPatterns["AQB_QUEST_ACCEPT"] = string.gsub(AdvQuestBookPatterns["AQB_QUEST_ACCEPT"], "\"%%s\"", "");
		AdvQuestBookPatterns["AQB_QUEST_MET"] = string.gsub(AdvQuestBookPatterns["AQB_QUEST_MET"], "\"%%s\"", "");
		AdvQuestBookPatterns["AQB_QUEST_ABANDON"] = string.gsub(AdvQuestBookPatterns["AQB_QUEST_ABANDON"], "\"%%s\"", "");
	elseif (string.find(AdvQuestBookPatterns["AQB_QUEST_COMPLETE2"], ".+%s%%s%s.+")) then
		j = AdvQuestBookPatterns["AQB_QUEST_COMPLETE2"];
		k = AdvQuestBookPatterns["AQB_QUEST_MET"];
		m = AdvQuestBookPatterns["AQB_QUEST_ABANDON"];
		j = "{"..j.."}";
		k = "{"..k.."}";
		m = "{"..m.."}";
		j = string.gsub(j, "%s%%s%s", "}{");
		k = string.gsub(k, "%s%%s%s", "}{");
		m = string.gsub(m, "%s%%s%s", "}{");
		i = 1;
		for n in string.gmatch(j, "{(.-)}") do
			AdvQuestBookPatterns["AQB_QUEST_COMPLETE2"..i] = n;
			i = i + 1;
		end
		for n in string.gmatch(k, "{(.-)}") do
			AdvQuestBookPatterns["AQB_QUEST_MET"..i] = n;
			i = i + 1;
		end
		for n in string.gmatch(m, "{(.-)}") do
			AdvQuestBookPatterns["AQB_QUEST_ABANDON"..i] = n;
			i = i + 1;
		end
	else
		AdvQuestBookPatterns["AQB_QUEST_COMPLETE2"] = string.gsub(AdvQuestBookPatterns["AQB_QUEST_COMPLETE2"], "%%s", "");
		AdvQuestBookPatterns["AQB_QUEST_MET"] = string.gsub(AdvQuestBookPatterns["AQB_QUEST_MET"], "%%s", "");
		AdvQuestBookPatterns["AQB_QUEST_ABANDON"] = string.gsub(AdvQuestBookPatterns["AQB_QUEST_ABANDON"], "%%s", "");
	end
	if (string.find(AdvQuestBookPatterns["AQB_QUEST_ACCEPT"], ".+%s%%s")) then
		AdvQuestBookPatterns["AQB_QUEST_ACCEPT"] = string.gsub(AdvQuestBookPatterns["AQB_QUEST_ACCEPT"], "%%s", "");
	elseif (string.find(AdvQuestBookPatterns["AQB_QUEST_ACCEPT"], ".+%s%%s%s.+")) then
		j = AdvQuestBookPatterns["AQB_QUEST_ACCEPT"];
		j = "{"..j.."}";
		j = string.gsub(j, "%s%%s%s", "}{");
		i = 1;
		for n in string.gmatch(j, "{(.-)}") do
			AdvQuestBookPatterns["AQB_QUEST_ACCEPT"..i] = n;
			i = i + 1;
		end
	end
	AdvQuestBookPatterns["AQB_QUEST_COMPLETE1"] = string.gsub(AdvQuestBookPatterns["AQB_QUEST_COMPLETE1"], "%(", "%%(");
	AdvQuestBookPatterns["AQB_QUEST_COMPLETE1"] = string.gsub(AdvQuestBookPatterns["AQB_QUEST_COMPLETE1"], "%)", "%%)");
	AdvQuestBookPatterns["PARTY_YOU_LEFT"] = string.gsub(AdvQuestBookPatterns["PARTY_YOU_LEFT"], "%.", "%%.");
	AdvQuestBookPatterns["PARTY_JOIN"] = string.gsub(AdvQuestBookPatterns["PARTY_JOIN"], "%.", "%%.");
	AdvQuestBookPatterns["AQB_QUEST_ABANDON"] = string.gsub(AdvQuestBookPatterns["AQB_QUEST_ABANDON"], "%.", "%%.");
	AdvQuestBookPatterns["PARTY_JOIN"] = string.gsub(AdvQuestBookPatterns["PARTY_JOIN"], "%.", "%%.");
	AdvQuestBookPatterns["PARTY_MEMBER_LEAVES"] = string.gsub(AdvQuestBookPatterns["PARTY_MEMBER_LEAVES"], "%.", "%%.");
	AdvQuestBookPatterns["PARTY_JOIN"] = string.gsub(AdvQuestBookPatterns["PARTY_JOIN"], "%[%%s%]", "");
	AdvQuestBookPatterns["PARTY_MEMBER_LEAVES"] = string.gsub(AdvQuestBookPatterns["PARTY_MEMBER_LEAVES"], "%[%%s%]", "");
	AdvQuestBookPatterns["AQB_QUEST_UPDATED"] = string.gsub(AdvQuestBookPatterns["AQB_QUEST_UPDATED"], "%%s", "", 1);
	AdvQuestBookPatterns["AQB_QUEST_UPDATED"] = string.gsub(AdvQuestBookPatterns["AQB_QUEST_UPDATED"], "%%s", "%(%.%+%)", 1);
	AdvQuestBookPatterns["AQB_QUEST_UPDATED"] = string.gsub(AdvQuestBookPatterns["AQB_QUEST_UPDATED"], "%%d", "%(%%d%+%)");
	AdvQuestBookPatterns["AQB_MATCH_AMOUNT1"] = string.gsub(AdvQuestBookPatterns["AQB_MATCH_AMOUNT1"], "%%s", "%(%.%+%)");
	AdvQuestBookPatterns["AQB_MATCH_AMOUNT1"] = string.gsub(AdvQuestBookPatterns["AQB_MATCH_AMOUNT1"], "%%d", "%(%%d%+%)");
	AdvQuestBookPatterns["AQB_MATCH_AMOUNT2"] = AdvQuestBookPatterns["AQB_MATCH_AMOUNT1"];
	AdvQuestBookPatterns["AQB_MATCH_AMOUNT1"] = AdvQuestBookPatterns["AQB_MATCH_AMOUNT1"]..AdvQuestBookPatterns["AQB_QUEST_COMPLETE1"];
	AdvQuestBookPatterns["AQB_QUEST_ACCEPT"] = string.gsub(AdvQuestBookPatterns["AQB_QUEST_ACCEPT"], "%s", "%%s");
	AdvQuestBookPatterns["AQB_QUEST_MET"] = string.gsub(AdvQuestBookPatterns["AQB_QUEST_MET"], "%s", "%%s");
	AdvQuestBookPatterns["AQB_QUEST_ABANDON"] = string.gsub(AdvQuestBookPatterns["AQB_QUEST_ABANDON"], "%s", "%%s");
	AdvQuestBookPatterns["AQB_QUEST_UPDATED"] = string.gsub(AdvQuestBookPatterns["AQB_QUEST_UPDATED"], "%s", "%%s");
	AdvQuestBookPatterns["AQB_QUEST_COMPLETE1"] = string.gsub(AdvQuestBookPatterns["AQB_QUEST_COMPLETE1"], "%s", "%%s");
	AdvQuestBookPatterns["AQB_QUEST_COMPLETE2"] = string.gsub(AdvQuestBookPatterns["AQB_QUEST_COMPLETE2"], "%s", "%%s");
	AdvQuestBookPatterns["AQB_MATCH_AMOUNT1"] = string.gsub(AdvQuestBookPatterns["AQB_MATCH_AMOUNT1"], "%s", "%%s");
	AdvQuestBookPatterns["PARTY_JOIN"] = string.gsub(AdvQuestBookPatterns["PARTY_JOIN"], "%s", "%%s");
	AdvQuestBookPatterns["PARTY_YOU_LEFT"] = string.gsub(AdvQuestBookPatterns["PARTY_YOU_LEFT"], "%s", "%%s");
	AdvQuestBookPatterns["PARTY_MEMBER_LEAVES"] = string.gsub(AdvQuestBookPatterns["PARTY_MEMBER_LEAVES"], "%s", "%%s");
	return;
end

function AdvQuestBook_CleanupOldData()
	local j, k, l, m;
	for j, k in pairs(AdvQuestBook_Dumped_Quests) do
		for l, m in pairs(k) do
			if (not AQB_IsEmpty(AdvQuestBook_Dumped_Quests[j][l]["info"]["descshort"], true)) then
				AdvQuestBook_Dumped_Quests[j][l]["info"]["descshort"] = nil;
				SaveVariables("AdvQuestBook_Dumped_Quests");
			end
			if (not AQB_IsEmpty(AdvQuestBook_Dumped_Quests[j][l]["info"]["desclong"], true)) then
				AdvQuestBook_Dumped_Quests[j][l]["info"]["desclong"] = nil;
				SaveVariables("AdvQuestBook_Dumped_Quests");
			end
		end
	end
	SaveVariables("AdvQuestBook_Dumped_Quests");
	return;
end

function AdvQuestBookCore_OnLoad(this)
	this:RegisterEvent("VARIABLES_LOADED");
end

function AdvQuestBookCore_EventHandler(this, event)
	if (event == "VARIABLES_LOADED") then
		AQB_SERVER = GetCurrentRealm();
		AQB_CurPlayer = UnitName("player");
		if (not AQB_IsEmpty(AdvQuestBook_Config, true)) then
			SaveVariables("AdvQuestBook_Config");
		end
		if (not AQB_IsEmpty(AdvQuestBook_Dumped_Quests, true)) then
			if (AQB_LANG_FILE == "en") then
				SaveVariables("AdvQuestBook_Dumped_Quests");
			end
		end
		if (AQB_LOCAL == "ENUS") then
			if (AdvQuestBook_Config ~= nil) then
				if (AdvQuestBook_Config["version"] ~= nil) then
					if (tonumber(AdvQuestBook_Config["version"]) < tonumber(1.32)) then
						if (not AQB_IsEmpty(AdvQuestBook_Dumped_Quests, true)) then
							AdvQuestBook_CleanupOldData();
						end
					end
				end
			end
		end
		AdvQuestBookConfig_Defaults();
		AQB_COUNT_DUMPED = 0;
		AQB_TEMP_QUESTS = {};
		AdvQuestBook_SetPatterns();
		local la;
		local langsupp = false;
		for _, la in pairs(AQB_SUPPORTED) do
			if (la == GetLanguage()) then
				langsupp = true;
				break;
			end
		end
		if (not langsupp) then
			AdvQuestBook_SavePatterns();
			DEFAULT_CHAT_FRAME:AddMessage("|cFFffffff"..AQB_ADDON_NAME..":|r Please send your |cffffffffSaveVariables.lua|r to |cffffffffCrypton|r on |cffffffffhttp://rom.curse.com|r when you exit the game. Your language is not supported yet and |cFFffffff"..AQB_ADDON_NAME..":|r has saved information regarding your language strings that are needed to add support.|r");
		end
	end
end
